#-*-coding:utf-8-*-

import MySQLdb
class fb_mysql():
    def __init__(self):
        try:
            self.conn = MySQLdb.Connect(host = 'localhost',user = 'root', passwd = '111111', db = 'renrengrap', port = 3306)
            self.cur = self.conn.cursor()
            self.conn.set_character_set('utf8')
            self.cur.execute('SET NAMES utf8;')
            self.cur.execute('SET CHARACTER SET utf8;')
            self.cur.execute('SET character_set_connection=utf8;')

    def close_db(self):
        try:
            self.cur.close()
            self.conn.close()


    def defind_by_self(self,mysqlstr):
        try:
            result = self.cur.execute(mysqlstr)
            if result !=0:
                return self.cur.fetchall()
            else:
                return None

             

    def insert_trending(self,data):
        if len(data)!=3:
            return None
        try:
            result = self.cur.execute('trqid =\'%s\';'%(data['trqid']))
            if result == 0:
                data['trqname'] = self.do_with_string(data['trqname'])
                self.cur.execute(" values(\"%s\",\"%s\",\"%s\");"%(data['trqid'],data['trqname'],data['trqurl']))
                self.conn.commit()


    def insert_fb_msg(self,data):
        import datetime
        nowtime = (datetime.datetime.now()-datetime.timedelta(hours=16)).strftime("%y-%m-%d %H:%M:%S")
        try:
            result = self.cur.execute("select update_time from user_msg where msgid = '%s';"%(data['msgid']))
            if result == 0 and data['shares_count']:
                data['message'] = self.do_with_string(data['message'])
                data['name'] = self.do_with_string(data['name'])
                print "msg==="+str(data)
                self.cur.execute(" values(\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",%d,%d);"%(data['msgid'],data['name'],data['message'],data['fromid'],data['fromname'],data['created_time'],nowtime,data['shares_count'],data['like_count']))
                self.conn.commit()
                return None
            else:
                oldtime = self.cur.fetchone()[0]
                self.cur.execute("update trending_msg set update_time = '%s' where msgid = '%s';"%(nowtime,data['msgid']))
                self.conn.commit()
                return oldtime

    def insert_fb_share(self,data):
        try:
            #print "share==" + str(data)
            data['from_name'] = self.do_with_string(data['from_name'])
            data['to_name'] = self.do_with_string(data['to_name'])
            self.cur.execute(" values(\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",%d,%d) fromid = \"%s\",from_name = \"%s\";"%(data['postid'],data['fromid'],data['toid'],data['from_name'],data['to_name'],data['created_time'],data['trend_mid'],data['like_count'],data['share_count'],data['fromid'],data['from_name']))
            self.conn.commit()

    
    def get_line_msg(self,time):
        try:
            result = self.cur.execute("'%s'"%(time))
            if result !=0:
                return self.cur.fetchall()
            else:
                return None


    def insert_fb_like(self,data):
        import datetime
        nowtime = datetime.datetime.now().strftime("%y-%m-%d %H:%M:%S")
        try:
            data['from_naem'] = self.do_with_string(data['from_name'])
            data['to_name'] = self.do_with_string(data['to_name'])
            self.cur.execute("values(\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\")  fromid = \"%s\",from_name = \"%s\";"%(data['fromid'],data['toid'],data['from_name'],data['to_name'],nowtime,data['trend_mid'],data['fromid'],data['from_name']))
            self.conn.commit()


    def insert_fb_comment(self,data):
        try:
            self.cur.execute("values(\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",%d ,\"%s\" fromid = \"%s\",from_name = \"%s\";"%(data['id'],data['fromid'],data['toid'],data['from_name'],data['to_name'],data['created_time'],data['like_count'],data['trend_mid'],data['fromid'],data['from_name']))
            self.conn.commit()


    def do_with_string(self,string):
        import re
        if string:
            return re.sub("\"","\"\"",string)
        else:
            return string
    
    def getidwithout(self):
        iid = dict()
        try:
            self.cur.execute()
            comment_from = self.cur.fetchall()
            for i in comment_from:
                iid[i[0]] = None
            self.cur.execute('')
            comment_to = self.cur.fetchall()
            for i in comment_to:
                iid[i[0]] = None
            self.cur.execute('')
            like_from = self.cur.fetchall()
            for i in like_from:
                iid[i[0]] = None
            self.cur.execute(' ')
            like_to = self.cur.fetchall()
            for i in like_to:
                iid[i[0]] = None
            self.cur.execute('')
            share_from = self.cur.fetchall()
            for i in share_from:
                iid[i[0]] = None
            self.cur.execute()
            share_to = self.cur.fetchall()
            for i in share_to:
                iid[i[0]] = None
            return iid.keys()


    def process_item(self, item,idone):
        for i in item:
            try:
                result = self.cur.execute('id_two=\'%s\' id_one=\'%s\';'%(idone,i))
                if result == 0:    
                    self.cur.execute("values(\"%s\",\"%s\");"%(idone,i))
                    self.conn.commit()


    def markfrd(self,idone):
        try:
            self.cur.execute('values(\"%s\");'%(idone))
            self.conn.commit()

    def show_result(self,strid,option):
        try:
            result = self.cur.execute(option ++strid)
            if result != 0:
                return self.cur.fetchone()






